'CSC 230 demonstration Program
'logon with arrays aof usernames and passwords

Public Class FrmLogon

    'declare arrays
    Dim Username As String()
    Dim Password As String()
    Dim ErrorCounter As Integer = 0

    '*********************************************************************************
    'establish the username and (corresponding) passwords
    Private Sub FrmLogon_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'instantiate arrays
        Username = New String(2) {}  'in VB the Number is the highest index, not the number of elements
        Password = New String(2) {}

        'initializ arrays element by element
        Username(0) = "Peter"
        Password(0) = "Beach"

        Username(1) = "Paul"
        Password(1) = "Blanket"

        Username(2) = "Mary"
        Password(2) = "Bingo"
    End Sub


    '********************************************************************************
    'straight face when text changed
    Private Sub txtUsername_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtUsername.TextChanged
        lblFace.Text = "KKKKK"
    End Sub

    '********************************************************************************
    'straight face when text changed
    Private Sub txtPassword_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtPassword.TextChanged
        lblFace.Text = "KKKKK"
    End Sub

    '********************************************************************************
    'see if username and password are a match
    'count invalid logon attempts, freeze the controls on third bad attempt
    Private Sub btnOK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOK.Click
        Dim HaveMatch As Boolean = False    'variable to say whether or not match was found
        'start off at false

        'Old Fashioned Approach: Loop Through Usernames 
        'Check password if and only if a match is found 
        'and only for that particular index
        'Dim i As Integer
        'For i = 0 To Username.GetUpperBound(0)
        '    If txtUsername.Text.Trim.ToLower = Username(i).Trim.ToLower Then
        '        If txtPassword.Text = Password(i) Then
        '            HaveMatch = True
        '        End If
        '    End If
        'Next

        Dim UserIndex As Integer

        UserIndex = Array.IndexOf(Username, txtUsername.Text)
        If UserIndex > -1 AndAlso Password(UserIndex) = txtPassword.Text Then
            HaveMatch = True
        End If
        'One advantage of the old fashioned approach was that we could 
        'make the username comparison case insensitive by using the 
        'ToLower method on both items we are comparing

        'display whetehr on not logon was successful
        If HaveMatch Then
            lblFace.Text = "JJJJJ"
        Else
            ErrorCounter += 1
            lblFace.Text = "LLLLL"
            If ErrorCounter < 3 Then
                MsgBox("Your logon attempt has failed. Try again.")
            Else
                MsgBox("That was your third attempt. Sorry.")
                txtUsername.Enabled = False
                txtPassword.Enabled = False
                btnOK.Enabled = False
            End If
        End If
    End Sub


End Class
